#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>

#define PLUGIN "kill_announcer"
#define VERSION "1.1"
#define AUTHOR "1xAero"

#define NULL 0
#define MAXPLAYERS 32

#define RED 0
#define GREEN 100
#define BLUE 150
#define X_AXIS -1.0
#define Y_AXIS 0.330
#define EFFECTS 0
#define FXTIME 0.025
#define HOLDTIME 4.0
#define FADEINTIME 0.025
#define FADEOUTTIME 0.5
#define CHANNEL 2

//Two frags in two seconds.
#define KILL_TIME 2.0

//Delay between sound repeat.
#define ANNOUNCER_DELAY 5.0

//Resets on amount of kills
#define RESET_KILL 2
#define SPREE_TRIGGER 4

//2 in 2
new Float: c_announcer_time[MAXPLAYERS + 1]
new Float: c_announcer_time_delay[MAXPLAYERS + 1]

//Reset on 2 more kills
new c_announcer_dual[MAXPLAYERS + 1]

//Killstreaks
new c_player_kill[MAXPLAYERS + 1]

#define SND_DOUBLE "announcer/double.wav"
#define SND_ENDED "announcer/ended.wav"

public plugin_init()
{
	#define TRUE 1

	register_plugin(PLUGIN, VERSION, AUTHOR);

	RegisterHam(Ham_Killed, "player", "HamF_Killed_Post", TRUE);
}

public plugin_precache()
{
	engfunc(EngFunc_PrecacheSound, SND_DOUBLE);
	engfunc(EngFunc_PrecacheSound, SND_ENDED);
}

//Player data.
public client_putinserver(iPlayer)
	Function_ResetPlayer(iPlayer);

public HamF_Killed_Post(iVictim, iKiller, Gib)
{
	if(!is_user_connected(iVictim) || !is_user_connected(iKiller)) 
		return;

	//Dunno't trigger announcer two times or too much
	if(c_announcer_time[iKiller] < get_gametime())
	{	
		c_announcer_time[iKiller] = get_gametime() + KILL_TIME;
		c_announcer_dual[iKiller] = NULL;
	}

	//Kill data.
	c_player_kill[iKiller] ++;
	c_announcer_dual[iKiller] ++;

	//if i killed 2 more player in 2 or less seconds and lets stop spam with sound if 2 more kills happened 
	if(iKiller != iVictim && c_announcer_time[iKiller] > get_gametime() && c_announcer_dual[iKiller] == RESET_KILL)
	{
		//Not too much.
		if(c_announcer_time_delay[iKiller] < get_gametime())
		{
			if(is_user_alive(iKiller))			
				PlaySound(iKiller, SND_DOUBLE);

			c_announcer_time_delay[iKiller] = get_gametime() + ANNOUNCER_DELAY;
		}	
	}	

	//Allocate space for info.
	new iMessage[64];

	//If killer is alive
	if(is_user_alive(iKiller))
	{
		switch(c_player_kill[iKiller])
		{
			//Medals
			case 5: iMessage = "KILLING SPREE", Function_SendMessage(iKiller, iMessage);
			case 10: iMessage = "RAGE", Function_SendMessage(iKiller, iMessage);
			case 15: iMessage = "GOD MODE", Function_SendMessage(iKiller, iMessage);
			case 20: iMessage = "FRENETIC", Function_SendMessage(iKiller, iMessage);
		}	
	}

	//Died, but killed someone with rocket or grenade.
	else
	{
		if(iKiller != iVictim)	
			iMessage = "FROM THE GRAVE", Function_SendMessage(iKiller, iMessage);
	}				

	//Spree ended
	if(c_player_kill[iVictim] > SPREE_TRIGGER)
		PlaySound(iVictim, SND_ENDED);	

	//Reset last.
	Function_ResetPlayer(iVictim);		
}

//Hud
stock Function_SendMessage(iPlayer, const iMessage[])
{
	set_hudmessage(RED, GREEN, BLUE, X_AXIS, Y_AXIS, EFFECTS, FXTIME, HOLDTIME, FADEINTIME, FADEOUTTIME, CHANNEL);
	show_hudmessage(iPlayer, "%s", iMessage); 	
}

//Play client sounds
stock PlaySound(iPlayer, const iSound[])
{
	if(equal(iSound[strlen(iSound) - 4], ".mp3"))
	{
		client_cmd(iPlayer, "mp3 stop");
		client_cmd(iPlayer, "mp3 play sound/%s", iSound);
	}
	else
		client_cmd(iPlayer, "spk ^"sound/%s^"", iSound);
}

//Reset data
stock Function_ResetPlayer(iPlayer)
{
	c_player_kill[iPlayer] = NULL;
	c_announcer_time[iPlayer] = get_gametime();
	c_announcer_time_delay[iPlayer] = get_gametime();		
}