//Fixed multiple entity remove calls, causing crashes.

#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>

#define PLUGIN "Half-Life: Player Camera"
#define VERSION "1.2"
#define AUTHOR "Arkshine/1xAero"

#define NULL 0
#define FALSE 0
#define TRUE 1

#define CAMERA_BIND 4976
#define CAMERA_UNBOUND 4977

#define MAXPLAYERS 32

new bool: c_player_toggle[MAXPLAYERS + 1]
new const c_player_camera[] = "3rd_person_camera"

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR);

	register_clcmd("say /cam", "Function_PlayerCamera");
	register_forward(FM_Think, "Forward_PlayerCamera", FALSE);
	RegisterHam(Ham_Spawn, "player", "HamF_PlayerSpawn_Post", TRUE);
}

public client_putinserver(iPlayer)
	c_player_toggle[iPlayer] = false;

public Function_PlayerCamera(iPlayer)
{
	c_player_toggle[iPlayer] = !c_player_toggle[iPlayer];
	
	if(c_player_toggle[iPlayer])
		Create_PlayerCamera(iPlayer);
	else
		Function_RemoveEntityByOwner(c_player_camera, iPlayer);	
}	

public Create_PlayerCamera(iPlayer)
{
	new iEnt = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"));

	if(!iEnt)
		return;
        
	set_pev(iEnt, pev_classname, c_player_camera);
	engfunc(EngFunc_SetModel, iEnt, "models/v_9mmhandgun.mdl");

	set_pev(iEnt, pev_solid, SOLID_TRIGGER);
	set_pev(iEnt, pev_movetype, MOVETYPE_FLYMISSILE);
	set_pev(iEnt, pev_owner, iPlayer);
	set_pev(iEnt, pev_iuser1, CAMERA_BIND);

	set_pev(iEnt, pev_rendermode, kRenderTransTexture);
	set_pev(iEnt, pev_renderamt, 0.0);

	engfunc(EngFunc_SetView, iPlayer, iEnt);
	set_pev(iEnt, pev_nextthink, get_gametime());
}

public Forward_PlayerCamera(iEnt)
{
	static iClassname[32];
	pev(iEnt, pev_classname, iClassname, charsmax(iClassname));

	if(!equal(iClassname, c_player_camera) || pev(iEnt, pev_iuser1) != CAMERA_BIND)
		return FMRES_IGNORED;

	static iOwner;
	iOwner = pev(iEnt, pev_owner);

	//Prevent game from crashing.
	if(!is_user_alive(iOwner) && pev(iEnt, pev_iuser1) == CAMERA_BIND)
	{
		engfunc(EngFunc_SetView, iOwner, iOwner);
		set_pev(iEnt, pev_iuser1, CAMERA_UNBOUND);
		set_pev(iEnt, pev_flags, FL_KILLME);
		dllfunc(DLLFunc_Think, iEnt);	
		
		return FMRES_IGNORED;
	}

	static Float: iOrigin[3], Float: fOrigin[3], Float: fAngle[3];
	pev(iOwner, pev_origin, iOrigin);
	pev(iOwner, pev_v_angle, fAngle);

	fOrigin = iOrigin;

	static Float: fVBack[3];
	angle_vector(fAngle, ANGLEVECTOR_FORWARD, fVBack);	

	iOrigin[2] += 20.0;

	iOrigin[0] += (-fVBack[0] * 150.0);
	iOrigin[1] += (-fVBack[1] * 150.0);
	iOrigin[2] += (-fVBack[2] * 150.0);
		
	engfunc(EngFunc_TraceLine, fOrigin, iOrigin, DONT_IGNORE_MONSTERS, iOwner, NULL);

	new Hit;
	Hit = get_tr2(NULL, TR_pHit);
	get_tr2(NULL, TR_vecEndPos, iOrigin);
		
	if(!Hit)
		return FMRES_IGNORED;
			
	engfunc(EngFunc_SetOrigin, iEnt, iOrigin);
		
	pev(iOwner, pev_velocity, fOrigin);
	set_pev(iEnt, pev_velocity, fOrigin);

	set_pev(iEnt, pev_angles, fAngle);
	set_pev(iEnt, pev_nextthink, get_gametime());

	return FMRES_HANDLED;
}

public HamF_PlayerSpawn_Post(iPlayer)
{
	if(!is_user_alive(iPlayer))
		return;
		
	if(c_player_toggle[iPlayer])
		Create_PlayerCamera(iPlayer);
}

stock Function_RemoveEntityByOwner(const iClassname[], iPlayer)
{
	new iEnt;	
	if((iEnt = engfunc(EngFunc_FindEntityByString, iEnt, "classname", iClassname)) > NULL)
	{
		if(pev(iEnt, pev_owner) == iPlayer && pev_valid(iEnt))
		{
			engfunc(EngFunc_SetView, iPlayer, iPlayer);
			set_pev(iEnt, pev_flags, FL_KILLME);
			dllfunc(DLLFunc_Think, iEnt);
		}
	}	
}